"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const TemplateResult_1 = require("./TemplateResult");
const ntriples = __importStar(require("./syntax/ntriples"));
class NQuadsTemplateResult extends TemplateResult_1.TemplateResult {
    // eslint-disable-next-line no-useless-constructor
    constructor(strings, values, turtle) {
        super(strings, values, turtle);
    }
    _evaluateDataset(dataset, options) {
        const [first, ...rest] = dataset;
        return rest.reduce((result, quad) => {
            const nextQuad = this._evaluateQuad(quad, options);
            return {
                value: `${result.value}\n${nextQuad.value}`,
                prefixes: result.prefixes,
            };
        }, this._evaluateQuad(first, options));
    }
    _evaluateQuad(quad, options) {
        const subject = this._evaluateTerm(quad.subject, options);
        const predicate = this._evaluateTerm(quad.predicate, options);
        const object = this._evaluateTerm(quad.object, options);
        const graph = this._evaluateTerm(quad.graph, options);
        return {
            value: `${subject.value} ${predicate.value} ${object.value} ${graph.value} .`,
            prefixes: [],
        };
    }
    _evaluateLiteral(term) {
        return {
            value: ntriples.literal(term),
            prefixes: [],
        };
    }
    _evaluateNamedNode(term) {
        return {
            value: ntriples.namedNode(term),
            prefixes: [],
        };
    }
    _evaluateBlankNode(term) {
        return {
            value: ntriples.blankNode(term),
            prefixes: [],
        };
    }
    get __defaultOptions() {
        return {
            sortGraphs: false,
        };
    }
    _getFinalString(result) {
        return result;
    }
}
exports.NQuadsTemplateResult = NQuadsTemplateResult;
exports.nquads = (strings, ...values) => new NQuadsTemplateResult(strings, values, exports.nquads);
