"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const rdf_ns_builders_1 = require("@tpluscode/rdf-ns-builders");
const xsdString = rdf_ns_builders_1.xsd.string;
function blankNode(term) {
    return `_:${term.value}`;
}
exports.blankNode = blankNode;
function namedNode(term) {
    return `<${term.value}>`;
}
exports.namedNode = namedNode;
function literal(term) {
    const value = `"${term.value}"`;
    if (term.language) {
        return `${value}@${term.language}`;
    }
    if (term.datatype && !term.datatype.equals(xsdString)) {
        return `${value}^^${namedNode(term.datatype)}`;
    }
    return value;
}
exports.literal = literal;
