import { BlankNode, DatasetCore, Literal, NamedNode, Quad, Term, Variable } from 'rdf-js';
import { Value } from './value';
declare type TagFunction<TImpl extends TemplateResult<TImpl, TValue, TOptions>, TValue extends Value<TImpl>, TOptions> = {
    (strings: TemplateStringsArray, ...values: TValue[]): TImpl;
};
export interface PartialString {
    value: string;
    prefixes: Iterable<string>;
}
export declare abstract class TemplateResult<TImpl extends TemplateResult<TImpl, TValue, TOptions>, TValue extends Value<TImpl>, TOptions> {
    protected readonly strings: TemplateStringsArray;
    protected readonly values: readonly Value<TImpl>[];
    protected readonly _tag: TagFunction<TImpl, DatasetCore | Quad | TImpl | Term | string | undefined | null, TOptions>;
    protected constructor(strings: TemplateStringsArray, values: Value<TImpl>[], tag: TagFunction<TImpl, Value<TImpl>, TOptions>);
    protected abstract get __defaultOptions(): TOptions;
    protected abstract _getFinalString(result: string, prefixes: Iterable<string>, options: TOptions): string;
    protected _evaluateLiteral(term: Literal, options: TOptions): PartialString;
    protected _evaluateNamedNode(term: NamedNode, options: TOptions): PartialString;
    protected _evaluateVariable(term: Variable): PartialString;
    protected _evaluateBlankNode(term: BlankNode): PartialString;
    protected _evaluateQuad(quad: Quad, options: TOptions): PartialString;
    protected _evaluateDataset(dataset: DatasetCore, options: TOptions): PartialString;
    toString(options?: TOptions): string;
    protected _toPartialString(options: TOptions): PartialString;
    protected _evaluateTerm(value: Term, options: TOptions): PartialString;
}
export {};
//# sourceMappingURL=TemplateResult.d.ts.map