import { BlankNode, DatasetCore, Literal, NamedNode, Quad, Term } from 'rdf-js';
import { Value } from './value';
import { PartialString, TemplateResult } from './TemplateResult';
export declare type NQuadsValue<T extends Term = Term> = Value<NQuadsTemplateResult, T>;
interface NQuadsOptions {
    sortGraphs: boolean;
}
export declare class NQuadsTemplateResult extends TemplateResult<NQuadsTemplateResult, NQuadsValue, NQuadsOptions> {
    constructor(strings: TemplateStringsArray, values: NQuadsValue[], turtle: (strings: TemplateStringsArray, ...values: NQuadsValue<any>[]) => NQuadsTemplateResult);
    protected _evaluateDataset(dataset: DatasetCore, options: NQuadsOptions): PartialString;
    protected _evaluateQuad(quad: Quad, options: NQuadsOptions): PartialString;
    protected _evaluateLiteral(term: Literal): PartialString;
    protected _evaluateNamedNode(term: NamedNode): PartialString;
    protected _evaluateBlankNode(term: BlankNode): PartialString;
    protected get __defaultOptions(): NQuadsOptions;
    protected _getFinalString(result: string): string;
}
export declare const nquads: (strings: TemplateStringsArray, ...values: Value<NQuadsTemplateResult, NamedNode | BlankNode | Literal>[]) => NQuadsTemplateResult;
export {};
//# sourceMappingURL=nquads.d.ts.map