import { BlankNode, Literal, NamedNode, Term, Variable } from 'rdf-js';
import { Value } from './value';
import { PartialString, TemplateResult } from './TemplateResult';
export declare type SparqlValue<T extends Term = Term> = Value<SparqlTemplateResult, T>;
interface SparqlOptions {
    base?: string;
    prologue?: boolean;
}
export declare class SparqlTemplateResult extends TemplateResult<SparqlTemplateResult, SparqlValue, SparqlOptions> {
    constructor(strings: TemplateStringsArray, values: SparqlValue[], turtle: (strings: TemplateStringsArray, ...values: SparqlValue<any>[]) => SparqlTemplateResult);
    protected get __defaultOptions(): SparqlOptions;
    protected _evaluateLiteral(term: Literal, options: SparqlOptions): PartialString;
    protected _evaluateNamedNode(term: NamedNode, options: SparqlOptions): PartialString;
    protected _evaluateBlankNode(term: BlankNode): PartialString;
    protected _evaluateVariable(term: Variable): PartialString;
    protected _getFinalString(result: string, prefixes: Iterable<string>, options: SparqlOptions): string;
}
export declare const sparql: (strings: TemplateStringsArray, ...values: Value<SparqlTemplateResult, Term>[]) => SparqlTemplateResult;
export {};
//# sourceMappingURL=sparql.d.ts.map