import { BlankNode, DatasetCore, DefaultGraph, Literal, NamedNode, Quad, Term } from 'rdf-js';
import { Value } from './value';
import { PartialString, TemplateResult } from './TemplateResult';
export declare type TurtleValue<T extends Term = Term> = Value<TurtleTemplateResult, T>;
interface TurtleOptions {
    directives?: boolean;
    graph: NamedNode | DefaultGraph;
}
export declare class TurtleTemplateResult extends TemplateResult<TurtleTemplateResult, TurtleValue, TurtleOptions> {
    constructor(strings: TemplateStringsArray, values: TurtleValue[], turtle: (strings: TemplateStringsArray, ...values: TurtleValue<any>[]) => TurtleTemplateResult);
    protected get __defaultOptions(): TurtleOptions;
    protected _evaluateBlankNode(term: BlankNode): PartialString;
    protected _evaluateLiteral(term: Literal): PartialString;
    protected _evaluateNamedNode(term: NamedNode): PartialString;
    protected _evaluateDataset(dataset: DatasetCore, options: TurtleOptions): PartialString;
    protected _evaluateQuad(quad: Quad, options: TurtleOptions): PartialString;
    protected _getFinalString(result: string, prefixes: Iterable<string>, options: TurtleOptions): string;
}
export declare const turtle: (strings: TemplateStringsArray, ...values: Value<TurtleTemplateResult, NamedNode | BlankNode | Literal>[]) => TurtleTemplateResult;
export {};
//# sourceMappingURL=turtle.d.ts.map